;/*
   failat 20
   sc gst=include:all.gst parms=register nostackcheck opttime optimize IRA_2.c
;   slink lib:c.o IRA.o IRA20_1.o IRA_2.o to IRA sc sd nd lib lib:sc.lib

   QUIT

   TABSIZE == 3 !!

   Author   : Tim Ruehsen
   Project  : IRA  -  680x0 Interactive ReAssembler
   Part     : IRA_2.c
   Purpose  : Contains data and some subroutines for IRA
   Version  : $VER: IRA_2.c 1.04
   Date     : 23.05.1995
   Copyright: (C)1993-1995 Tim Ruehsen

*/

#include "ira.h"

struct OpCode
{
   UBYTE *mnemonic;
   UWORD result;
   UWORD maske;
   UWORD sourceadr;
   UWORD destadr;
   UWORD cputype;
   UBYTE flags;
};

char cpuname[][8] =
{
   "MC68000","MC68010","MC68020","MC68030","MC68040","MC68060"
};

char *opcode[] =
{
/*  0*/ "BF","","",
/*  3*/ "ILLEGAL","NOP","RESET","RTE","RTR","RTS","RTD","STOP","TRAPV","MOVEC",
/* 13*/ "BKPT","SWAP","LINK","LINK.L","UNLK","EXT","EXT.L","EXTB.L","MOVE.L","MOVE.L","TRAP",
/* 24*/   "DIV","MUL","TAS","JMP","JSR","PEA","NBCD","MOVE","MOVE","MOVE","MOVE",
/* 35*/   "MOVEM","MOVEM","MOVEM.L","MOVEM.L","LEA","CHK","CHK.L","CLR",
/* 43*/   "TST","NOT","NEG","NEGX",
/* 47*/   "ADDA","ADDA.L","ADDX","ADDX","ADD","ADD","EXG","EXG","EXG",
/* 56*/   "ABCD","ABCD","MULS","MULU","AND","AND",
/* 62*/   "CMPA","CMPA.L","CMPM","CMP","EOR",
/* 67*/   "PACK","PACK","UNPK","UNPK","SBCD","SBCD","DIVS","DIVU","OR","OR",
/* 77*/   "MOVE.B","MOVEA","MOVE","MOVEA.L","MOVE.L","MOVEQ",
/* 83*/   "SUBA","SUBA.L","SUBX","SUBX","SUB","SUB",
/* 89*/   "MOVEP","MOVEP","MOVEP.L","MOVEP.L","B","CAS2","CAS","RTM","CALLM","C",
/* 99*/   "CMPI","EORI","ANDI","ADDI","SUBI","ORI","B","MOVES",
/*107*/   "DB","TRAP","TRAP","TRAP","S","ADDQ","SUBQ","B",
/*115*/   "MOVE16","MOVE16","C"," ",
   "@" // [END]
};

UWORD result[] =
{
   0xe8c0,0xe0c0,0xe000,
   0x4afc,0x4e71,0x4e70,0x4e73,0x4e77,0x4e75,0x4e74,0x4e72,0x4e76,0x4e7a,
   0x4848,0x4840,0x4e50,0x4808,0x4e58,0x4880,0x48c0,0x49c0,0x4e68,0x4e60,0x4e40,
   0x4c40,0x4c00,0x4ac0,0x4ec0,0x4e80,0x4840,0x4800,0x44c0,0x46c0,0x40c0,0x42c0,
   0x4880,0x4c80,0x48c0,0x4cc0,0x41c0,0x4180,0x4100,0x4200,
   0x4a00,0x4600,0x4400,0x4000,
   0xd0c0,0xd1c0,0xd100,0xd108,0xd100,0xd000,0xc140,0xc148,0xc188,
   0xc100,0xc108,0xc1c0,0xc0c0,0xc100,0xc000,
   0xb0c0,0xb1c0,0xb108,0xb000,0xb100,
   0x8148,0x8140,0x8188,0x8180,0x8100,0x8108,0x81c0,0x80c0,0x8100,0x8000,
   0x1000,0x3040,0x3000,0x2040,0x2000,0x7000,
   0x90c0,0x91c0,0x9100,0x9108,0x9100,0x9000,
   0x0188,0x0108,0x01c8,0x0148,0x0800,0x08fc,0x08c0,0x06c0,0x06c0,0x00c0,
   0x0c00,0x0a00,0x0200,0x0600,0x0400,0x0000,0x0100,0x0e00,
   0x50c8,0x50fc,0x50fa,0x50fb,0x50c0,0x5000,0x5100,0x6000,
   0xf620,0xf600,0xf400,0x0000
};

UWORD maske[] =
{
   0xf8c0,0xf8c0,0xf000,
   0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xfffe,
   0xfff8,0xfff8,0xfff8,0xfff8,0xfff8,0xfff8,0xfff8,0xfff8,0xfff8,0xfff8,0xfff0,
   0xffc0,0xffc0,0xffc0,0xffc0,0xffc0,0xffc0,0xffc0,0xffc0,0xffc0,0xffc0,0xffc0,
   0xffc0,0xffc0,0xffc0,0xffc0,0xf1c0,0xf1c0,0xf1c0,0xff00,
   0xff00,0xff00,0xff00,0xff00,
   0xf1c0,0xf1c0,0xf138,0xf138,0xf100,0xf100,0xf1f8,0xf1f8,0xf1f8,
   0xf1f8,0xf1f8,0xf1c0,0xf1c0,0xf100,0xf100,
   0xf1c0,0xf1c0,0xf138,0xf100,0xf100,
   0xf1f8,0xf1f8,0xf1f8,0xf1f8,0xf1f8,0xf1f8,0xf1c0,0xf1c0,0xf100,0xf100,
   0xf000,0xf1c0,0xf000,0xf1c0,0xf000,0xf100,
   0xf1c0,0xf1c0,0xf138,0xf138,0xf100,0xf100,
   0xf1f8,0xf1f8,0xf1f8,0xf1f8,0xff00,0xf9ff,0xf9c0,0xfff0,0xffc0,0xf9c0,
   0xff00,0xff00,0xff00,0xff00,0xff00,0xff00,0xf100,0xff00,
   0xf0f8,0xf0ff,0xf0ff,0xf0ff,0xf0c0,0xf100,0xf100,0xf000,
   0xfff8,0xffe0,0xff10,0x0000
};

   /* Achtung ! Gilt nur fuer sourceadr[] und destadr[]. */
   /* Bit 15 (0x8000) : 1 ==> Im unteren Byte steht die einzig moegl. */
   /*                         Adressierungsart. */
   /* Bit 13 (0x2000) : 0 ==> reg=reg2 */
   /*                     1 ==> reg=reg1 */
   /*                     Bestimmt, ob reg1 oder reg2 bestimmend ist. */

UWORD sourceadr[] =
{
   0x0000,0x0000,0x0000,
   0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
   0x0000,0x0000,0x8001,0x8001,0x0000,0x0000,0x0000,0x0000,0x800e,0x8001,0x0000,
   0x0bff,0x0bff,0x0000,0x0000,0x0000,0x0000,0x0000,0x0bff,0x0bff,0x800d,0x800c,
   0x800f,0x037e,0x800f,0x037e,0x027e,0x0bff,0x0bff,0x0000,
   0x0bf8,0x0000,0x0000,0x0000,
   0x0fff,0x0fff,0x8000,0x8004,0xa000,0x0fff,0xa000,0xa001,0xa000,
   0x8000,0x8004,0x0bff,0x0bff,0xa000,0x0bff,
   0x0fff,0x0fff,0x8003,0x0fff,0xa000,
   0x8004,0x8000,0x8004,0x8000,0x8000,0x8004,0x0bff,0x0bff,0xa000,0x0bff,
   0x0fff,0x0fff,0x0fff,0x0fff,0x0fff,0x8014,
   0x0fff,0x0fff,0x8000,0x8004,0xa000,0x0fff,
   0xa000,0x8005,0xa000,0x8005,0x8017,0x0000,0x801c,0x0000,0x800b,0x027e,
   0x800b,0x800b,0x800b,0x800b,0x800b,0x800b,0xa017,0x0000,
   0x8000,0x0000,0x800b,0x800b,0x0000,0xa010,0xa010,0x0000,
   0x8003,0x0000,0x8020,0x8000+NOADRMODE
};

UWORD destadr[] =
{
   0x8019,0x03f8,0x8000,
   0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x8016,0x8018,0x0000,0x8021,
   0x8011,0x8000,0x8016,0x801e,0x8001,0x8000,0x8000,0x8000,0x8001,0x800e,0x8013,
   0x801d,0x801d,0x0bf8,0x027e,0x027e,0x027e,0x0bf8,0x800c,0x800d,0x0bf8,0x0bf8,
   0x02f8,0x800f,0x02f8,0x800f,0xa001,0xa000,0xa000,0x0bf8,
   0x0000,0x0bf8,0x0bf8,0x0bf8,
   0xa001,0xa001,0xa000,0xa004,0x03f8,0xa000,0x8000,0x8001,0x8001,
   0xa000,0xa004,0xa000,0xa000,0x03f8,0xa000,
   0xa001,0xa001,0xa003,0xa000,0x0bf8,
   0xa004,0xa000,0xa004,0xa000,0xa000,0xa004,0xa000,0xa000,0x03f8,0xa000,
   0x0bf8,0xa001,0x0bf8,0xa001,0x0bf8,0xa000,
   0xa001,0xa001,0xa000,0xa004,0x03f8,0xa000,
   0x8005,0xa000,0x8005,0xa000,0x0000,0x801b,0x03f8,0x801a,0x027e,0x0000,
   0x0bf8,0x0bf9,0x0bf9,0x0bf8,0x0bf8,0x0bf9,0x0000,0x0000,
   0x8012,0x0000,0x0000,0x0000,0x0bf8,0x0ff8,0x0ff8,0x8015,
   0x801f,0x0000,0x8002,0x0000
};

/*
   FLAGS:
   0x80 : operand size is in bits [0:1] (0=.B,1=.W,2=.L)
          else use opsize from opcode
   0x40 : operand size has to be appended to mnemonic
   0x20 : one further word has to be saved before further processing.
   0x10 : the condition code identifier has to be appended to the mnemonic.
*/

UBYTE flags[] =
{
   0x20,0x81,0x40,
   0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x82,
   0x80,0x80,0x81,0x81,0x81,0x81,0x82,0x82,0x82,0x82,0x80,
   0xa2,0xa2,0x80,0x81,0x81,0x80,0x80,0x81,0x81,0x81,0x81,
   0xa1,0xa1,0xa2,0xa2,0x80,0x81,0x82,0x40,
   0x40,0x40,0x40,0x40,
   0x81,0x82,0x40,0x40,0x40,0x40,0x82,0x82,0x82,
   0x80,0x80,0x81,0x81,0x40,0x40,
   0x81,0x82,0x40,0x40,0x40,
   0xa1,0xa1,0xa1,0xa1,0x80,0x80,0x81,0x81,0x40,0x40,
   0x80,0x81,0x81,0x82,0x82,0x80,
   0x81,0x82,0x40,0x40,0x40,0x40,
   0x81,0x81,0x82,0x82,0x00,0x20,0x00,0x00,0x81,0x40,
   0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x40,
   0x90,0x90,0x91,0x92,0x90,0x40,0x40,0x90,
   0x82,0x82,0x00,0x80
};

UBYTE cputype[] =
{
   M020UP,M680x0,M680x0,
   M680x0,M680x0,M680x0,M680x0,M680x0,M680x0,M010UP,M680x0,M680x0,M010UP,
   M020UP,M680x0,M680x0,M020UP,M680x0,M680x0,M680x0,M020UP,M680x0,M680x0,M680x0,
   M020UP,M020UP,M680x0,M680x0,M680x0,M680x0,M680x0,M680x0,M680x0,M680x0,M010UP,
   M680x0,M680x0,M680x0,M680x0,M680x0,M680x0,M020UP,M680x0,
   M680x0,M680x0,M680x0,M680x0,
   M680x0,M680x0,M680x0,M680x0,M680x0,M680x0,M680x0,M680x0,M680x0,
   M680x0,M680x0,M680x0,M680x0,M680x0,M680x0,
   M680x0,M680x0,M680x0,M680x0,M680x0,
   M020UP,M020UP,M020UP,M020UP,M680x0,M680x0,M680x0,M680x0,M680x0,M680x0,
   M680x0,M680x0,M680x0,M680x0,M680x0,M680x0,
   M680x0,M680x0,M680x0,M680x0,M680x0,M680x0,
   M680x0,M680x0,M680x0,M680x0,M680x0,M020UP,M020UP,M68020,M68020,M020UP,
   M680x0,M680x0,M680x0,M680x0,M680x0,M680x0,M680x0,M010UP,
   M680x0,M020UP,M020UP,M020UP,M680x0,M680x0,M680x0,M680x0,
   M040UP,M040UP,M68040,M680x0
};

char *bitshift[] =
{
   "AS","LS","ROX","RO",
   "@" // [END]
};

char *condcode[] =
{
   "T","F","HI","LS","CC","CS","NE","EQ","VC","VS","PL","MI",
   "GE","LT","GT","LE","RA","SR",
   "@" // [END]
};

char *mmu_cc[] =
{
   "BS","BC","LS","LC","SS","SC","AS","AC",
   "WS","WC","IS","IC","GS","GC","CS","CC"
   "@" // [END]
};

char *fpu_cc[] =
{
   "F","EQ","OGT","OGE","OLT","OLE","OGL","OR",
   "UN","UEQ","UGT","UGE","ULT","ULE","NE","T",
   "SF","SEQ","GT","GE","LT","LE","GL","GLE",
   "NGLE","NGL","NLE","NLT","NGE","NGT","SNE","ST"
   "@" // [END]
};

char *extension[] =
{
   ".B","",".L",
   "@" // [END]
};

char *caches[] =
{
   "NC","DC","IC","BC",
   "@" // [END]
};

char *bitop[] =
{
   "TST","CHG","CLR","SET",
   "@" // [END]
};

char *memtypename[] =
{
   "PUBLIC","CHIP","FAST","???",
   "@" // [END]
};

char *modname[] =
{
   "CODE","DATA","BSS",
   "@" // [END]
};

char *bitfield[] =
{
   "TST","EXTU","CHG","EXTS","CLR","FFO","SET","INS",
   "@" // [END]
};

char *cregname[] =
{
   "SFC","DFC","CACR","TC", "ITT0","ITT1", "DTT0","DTT1","BUSCR",
   "USP","VBR","CAAR","MSP","ISP", "MMUSR","URP", "SRP","PCR",
   "@" // [END]
};

UWORD cregflag[18] =
{
   M010UP,M010UP,M020UP,M040UP,M040UP,M040UP,M040UP,M040UP,M68060,
   M010UP,M010UP,M68020|M68030,M020UP,M020UP,M68040,M040UP,M040UP,M68060
};

struct x_adr x_adrs[] =
{
   // =====================
   { "STACK_INIT",   0x0000, },
   { "PC_INIT",   0x0004, },
   { "BUS_ERROR",  0x0008, },
   { "ADR_ERROR",  0x000C, },
   { "ILLEG_OPC",  0x0010, },
   { "DIVISION0",  0x0014, },
   { "CHK",        0x0018, },
   { "TRAPV",      0x001C, },
   { "PRIVILEG",   0x0020, },
   { "TRACE",      0x0024, },
   { "LINEA_EMU",  0x0028, },
   { "LINEF_EMU",  0x002C, },
   // ---------------------
   { "INT_NOINI",  0x003C, },
   // ---------------------
   { "INT_WRONG",  0x0060, },
   { "AUTO_INT1",  0x0064, },
   { "AUTO_INT2",  0x0068, },
   { "AUTO_INT3",  0x006C, },
   { "AUTO_INT4",  0x0070, },
   { "AUTO_INT5",  0x0074, },
   { "AUTO_INT6",  0x0078, },
   { "NMI",        0x007C, },
   // ---------------------
   { "TRAP_01",    0x0080, },
   { "TRAP_02",    0x0084, },
   { "TRAP_03",    0x0088, },
   { "TRAP_04",    0x008C, },
   { "TRAP_05",    0x0090, },
   { "TRAP_06",    0x0094, },
   { "TRAP_07",    0x0098, },
   { "TRAP_08",    0x009C, },
   { "TRAP_09",    0x00A0, },
   { "TRAP_10",    0x00A4, },
   { "TRAP_11",    0x00A8, },
   { "TRAP_12",    0x00AC, },
   { "TRAP_13",    0x00B0, },
   { "TRAP_14",    0x00B4, },
   { "TRAP_15",    0x00B8, },
   // =====================
};


extern UBYTE
  **SymbolName,
    StdName[STDNAMELENGTH];

extern void
    InsertSymbol(UBYTE *, ULONG value),
    InsertCodeAdr(ULONG);

extern UWORD
   *buffer,
   *memtype,
   *DRelocBuffer;

extern ULONG
    PASS,
    prgstart,
    prgende,
    prgcount,
    pflags,
    basesec,
    SymbolCount,
   *SymbolValue,
    LabelMax,
   *LabelAdr,
   *LabelAdr2,
    labcount,
    relocount,
    relocmax,
   *RelocAdr,
   *RelocVal,
   *RelocOff,
   *RelocMod,
   *RelocBuffer,
    RelocNumber,
    nextreloc,
  **modulstrt,
   *moduloffs,
   *modultab,
   *modultype,
    modulcount,
    modulcnt,
    LastModul,
    XRefCount,
    LabX_len,
   *XRefListe;

extern FILE
    *sourcefile,
    *targetfile,
    *binfile;

extern void
      Freemem(void *ptr,ULONG cnt),
      ExitPrg(char *, ...);

/******************************************************************************/

static void do_lower(char **src)
{
   int ta=0;
   while(src[ta][0]!='@') strlwr(src[ta++]);
}

static void do_upper(char **src)
{
   int ta=0;
   while(src[ta][0]!='@') strupr(src[ta++]);
}

void set_opcode_text_case(void)
{
   if(upper_case==0){
      do_lower(opcode);
      do_lower(bitshift);
      do_lower(condcode);
      do_lower(mmu_cc);
      do_lower(fpu_cc);
      do_lower(extension);
      do_lower(bitop);
      do_lower(memtypename);
      do_lower(modname);
      do_lower(bitfield);
      do_lower(cregname);
   }
   else{
      do_upper(opcode);
      do_upper(bitshift);
      do_upper(condcode);
      do_upper(mmu_cc);
      do_upper(fpu_cc);
      do_upper(extension);
      do_upper(bitop);
      do_upper(memtypename);
      do_upper(modname);
      do_upper(bitfield);
      do_upper(cregname);
   }
}

void mnecasecat(char *src)
{
   if(upper_case==0)
      strcat(mnebuf, strlwr(src));
   else
      strcat(mnebuf, strupr(src));
}

void adrcasecat(char *src)
{
   if(upper_case==0)
      strcat(adrbuf, strlwr(src));
   else
      strcat(adrbuf, strupr(src));
}

void dtacasecat(char *src)
{
   if(upper_case==0)
      strcat(dtabuf, strlwr(src));
   else
      strcat(dtabuf, strupr(src));
}

/******************************************************************************/

void *GetPMem(ULONG len)
{
   void *ptr=0;

   if (len) {
      if (!(ptr = AllocMem(len,MEMF_CLEAR)))
         ExitPrg("Not enough memory (%lu Bytes) !\n",len);
      /* printf("Allo: %08X  %8ld\n",ptr,len); */
   }
   return(ptr);
}

ULONG FileLength(UBYTE *name)
{
   LONG len;
   FILE *file;
   if (name) {
      if (!(file = fopen(name,"rb")))
         ExitPrg("Can't open %s\n",name);
      if (fseek(file,0,SEEK_END))
         ExitPrg("seek error (%s)\n",name);
      if ((len = ftell(file)) == -1L)
         ExitPrg("ftell error (%s)\n",name);
      fclose(file);
   }
   else printf("FileLength: Got no Name!\n");

   return ((ULONG)len);
}

void *GetNewVarBuffer(void *p,ULONG size)
{
   void *np;

   np = GetPMem(size*8);
   lmovmem(p,np,size);
   Freemem(p,size*4);
   return(np);
}

int _abort(void)
{
   fflush(stdout);
   ExitPrg("***User-Break\n");
   return 1;
}

ULONG ReadSymbol(FILE *file,ULONG *val,UBYTE *type)
{
   ULONG length,dummy;
   if ((fread(&length,4,1,file)) != 1) ExitPrg("ReadSymbol error (1)\n");
   if (!length) return(0);
   if (type) {
      *type   = (length>>24);
      length &= 0x00FFFFFF;
   }
   length*=4;
   if (length >= STDNAMELENGTH) dummy=STDNAMELENGTH-1;
   else dummy=length;
   if ((fread(StdName,1,dummy,file)) != dummy) ExitPrg("ReadSymbol error (2)\n");
   StdName[dummy] = 0;
   if (length > dummy) fseek(file,length-dummy,SEEK_CUR);
   if (val)
      if ((fread(val,4,1,file)) != 1) ExitPrg("ReadSymbol error (3)\n");
   return(dummy);
}

void InsertReloc(ULONG adr,ULONG value,LONG offs,ULONG mod)
/*
   adr     Adresse, auf der reloziert wird
   value   Inhalt der Adresse (stellt auch eine Adresse dar)
*/
{
   ULONG l=0,m,r=relocount;

   /* Dieser Fall tritt sehr haeufig auf */
   if (adr > RelocAdr[relocount-1] && relocount) {
         RelocAdr[relocount]   = adr;
         RelocVal[relocount]   = value;
         RelocOff[relocount]   = offs;
         RelocMod[relocount++] = mod;
   }
   else {
      /* Binaeres Suchen von adr */
      while (l<r) {
         m=(l+r)/2;
         if (RelocAdr[m]<adr) l=m+1;
         else                 r=m;
      }
      if (RelocAdr[r]!=adr || r==relocount) {
         lmovmem(&RelocAdr[r],&RelocAdr[r+1],relocount-r);
         lmovmem(&RelocOff[r],&RelocOff[r+1],relocount-r);
         lmovmem(&RelocVal[r],&RelocVal[r+1],relocount-r);
         lmovmem(&RelocMod[r],&RelocMod[r+1],relocount-r);
         RelocAdr[r] = adr;
         RelocOff[r] = offs;
         RelocVal[r] = value;
         RelocMod[r] = mod;
         relocount++;
      }
   }
   if (relocount == relocmax) {
      RelocAdr = GetNewVarBuffer(RelocAdr,relocmax);
      RelocVal = GetNewVarBuffer(RelocVal,relocmax);
      RelocOff = GetNewVarBuffer(RelocOff,relocmax);
      RelocMod = GetNewVarBuffer(RelocMod,relocmax);
      relocmax *= 2;
   }

}

void InsertLabel(LONG adr)
{
   ULONG l=0,m,r=labcount;

   if (PASS == 0) return;

   /* Dieser Fall tritt sehr haeufig auf */
   if (adr > (long)LabelAdr[labcount-1] && labcount) {
      LabelAdr[labcount++] = adr;
   }
   else {
      /* Binaeres Suchen von adr */
      while (l<r) {
         m=(l+r)/2;
         if ((long)LabelAdr[m]<adr) l=m+1;
         else                         r=m;
      }
      if (LabelAdr[r]!=adr || r==labcount) {
         lmovmem(&LabelAdr[r],&LabelAdr[r+1],labcount-r);
         LabelAdr[r] = adr;
         labcount++;
      }
   }
   if (labcount == LabelMax) {
      LabelAdr  = GetNewVarBuffer(LabelAdr,LabelMax);
      LabelMax *= 2;
   }
}

void InsertXref(ULONG adr)
{
   ULONG  l=0,m,r=XRefCount;

   if (PASS == 0) return;

   /* Binaeres Suchen von adr */
   while (l<r) {
      m=(l+r)/2;
      if (XRefListe[m]<adr) l=m+1;
      else                  r=m;
   }
   if (XRefListe[r]!=adr || r==XRefCount) {
      lmovmem(&XRefListe[r],&XRefListe[r+1],XRefCount-r);
      XRefListe[r]   = adr;
      XRefCount++;
   }

   if (XRefCount == LabX_len) {
      XRefListe   = GetNewVarBuffer(XRefListe,LabX_len);
      LabX_len *= 2;
   }
}

extern UWORD opcstart[16];
extern UWORD opccount[16];
extern UWORD SIZEOF_RESULT;
extern ULONG ADRCOUNT;

void InitOpcode(void)
{
   UWORD i;

   SIZEOF_RESULT=sizeof(result);
   ADRCOUNT=sizeof(x_adrs)/sizeof(struct x_adr);
   for(i=0;i<(sizeof(result))/sizeof(UWORD)-1;i++) {
      if (opccount[result[i]>>12]==0) opcstart[result[i]>>12]=i;
      opccount[result[i]>>12]++;
   }

   if (sizeof(result)!=sizeof(sourceadr))
      ExitPrg("sizeof(result) != sizeof(sourceadr)");
   if (sizeof(result)!=sizeof(destadr))
      ExitPrg("sizeof(result) != sizeof(destadr)");
   if (sizeof(result)!=sizeof(maske))
      ExitPrg("sizeof(result) != sizeof(maske)");
   if (sizeof(result)/sizeof(UWORD)!=sizeof(flags)/sizeof(UBYTE))
      ExitPrg("sizeof(result) != sizeof(flags)");

}

int GetSymbol(ULONG adr)
{
   ULONG i;

   // printf("GETSYMBOL(%08X)\n",adr);

   for(i=0;i<SymbolCount;i++) {
      if (SymbolValue[i] == adr) {
         adrcat(SymbolName[i]);
         return(-1);
      }
   }
   return(0);
}

void GetLabel(LONG adr,UWORD adrmode)
{
   ULONG dummy=-1;
   char  buf[20];
   ULONG l=0,m,r=labcount,r2;

   /* Search for an entry in LabelAdr */
   while (l<r) {
      m=(l+r)/2;
      if ((long)LabelAdr[m]<adr) l=m+1;
      else                       r=m;
   }
   if (LabelAdr[r]!=adr) {
      fprintf(stderr,"ADR=%08x not found! (mode=%d) relocount=%ld nextreloc=%ld\n",adr,adrmode,relocount,nextreloc);
      fprintf(stderr,"LabelAdr[l=%lu]=%08x\n",l,LabelAdr[l]);
      fprintf(stderr,"LabelAdr[m=%lu]=%08x\n",m,LabelAdr[m]);
      fprintf(stderr,"LabelAdr[r=%lu]=%08x\n\n",r,LabelAdr[r]);
      adrcat("LAB_");
      adrcat(itohex(adr,8));
      return;
   }

   /* to avoid several label at the same address */
   r2=r;
   while(r && (LabelAdr2[r]==LabelAdr2[r-1])) r--;

   /* Pass 2 */
   if (adrmode==9999) {
      if (LabelAdr2[r] == moduloffs[RelocMod[nextreloc]]) {
         if (!GetSymbol(LabelAdr[r2])) {
            adrcat("SECSTRT_");
            adrcat(ira_itoa(RelocMod[nextreloc]));
         }
         if (dummy=RelocOff[nextreloc]) {
            if ((LONG)RelocOff[nextreloc] > 0) adrcat("+");
            adrcat(ira_itoa(RelocOff[nextreloc]));
         }
         else if (dummy = LabelAdr[r2]-LabelAdr2[r]) {
            adrcat("+");
            adrcat(ira_itoa(dummy));
         }
      } else {
         if (!GetSymbol(LabelAdr[r2])) {
            sprintf(buf,"LAB_%04lX",r);
            adrcat(buf);
         }
         if (dummy = LabelAdr[r2]-LabelAdr2[r]) {
            adrcat("+");
            adrcat(ira_itoa(dummy));
         }
      }
   } else if (LabelAdr2[r] == moduloffs[modulcnt] && adrmode!=5) {
      if (!GetSymbol(LabelAdr[r2])) {
         adrcat("SECSTRT_");
         adrcat(ira_itoa(modulcnt));
      }
      if (adr > (long)moduloffs[modulcnt]) {
         adrcat("+");
         adrcat(ira_itoa(adr-moduloffs[modulcnt]));
      }
      else if (adr < (long)moduloffs[modulcnt])
         adrcat(ira_itoa(adr-moduloffs[modulcnt]));
   } else {
      if (!GetSymbol(LabelAdr[r2])) {
         if (adrmode==5 && LabelAdr2[r2]==moduloffs[basesec]) {
            adrcat("SECSTRT_");
            adrcat(ira_itoa(basesec));
         }
         else {
            sprintf(buf,"LAB_%04lX",r);
            adrcat(buf);
         }
      }
      if (dummy = LabelAdr[r2]-LabelAdr2[r]) {
         adrcat("+");
         adrcat(ira_itoa(dummy));
      }
   }
}

void GetExtName(ULONG index)
{
   register ULONG xref;
   ULONG  l=0,m,r=ADRCOUNT;

   xref = XRefListe[index];
   if (xref >= 0xDC0000 && xref<=0xDCFFFF) xref&=0xDC00FC;

   /* Binaere Suche nach Eintrag */
   while (l<r) {
      m=(l+r)/2;
      if (x_adrs[m].adr<xref) l=m+1;
      else                    r=m;
   }
   if (x_adrs[r].adr!=xref) {
      adrcat("EXT_");
      adrcat(itohex(index,4));
   }
   else
      adrcat(&x_adrs[r].name[0]);
}

void GetXref(ULONG adr)
{
   ULONG l=0,m,r=XRefCount;

   /* Vorhandenen Eintrag in XRefListe suchen */
   while (l<r) {
      m=(l+r)/2;
      if (XRefListe[m]<adr) l=m+1;
      else                  r=m;
   }
   if (XRefListe[r]!=adr) {
      fprintf(stderr,"XRef ADR=%08x not found!\n",adr);
      adrcat("EXT_");
      adrcat(itohex(adr,8));
   }
   else GetExtName(r);
}

void CreateSymbol(char *name,ULONG symptr,ULONG refptr,ULONG module,ULONG number)
{
   char symbol[32];

   strcpy(symbol,name);
   if (number) strcat(symbol,ira_itoa(number));
   InsertReloc(refptr+prgstart,symptr,0L,module);
   InsertSymbol(symbol,symptr);
   InsertLabel(symptr);
}


void WriteTarget(void *ptr,ULONG len)
{
   if((fwrite(ptr,1,len,targetfile)) != len)
      ExitPrg("*** File Write Error ***\n");
}
